/**
 * 
 */
package edu.wmich.cs1120.randomfileop;

import java.io.DataOutputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.RandomAccessFile;

/**
 * @author sww
 *
 */
public class RandomFileOps {
	private int sizeofWord;
	private String filename;
	
	RandomFileOps(int i, String name)
	{
		sizeofWord = i;
		filename = name;
	}
	
	public void write2RandomFile() throws IOException
	{
		char[] chars = {'H','l','o','l','e','d','W','r','l','o', ' ', '!'};
		int[] numbers = { 1,3,4,5,3,4,0,1,1,2,10,1,0,2,1,7,2,3,9,1,2,4,-3,2 };
		// h 1 3,l 4 5, o 3 4, l 0 1, e 1 2, d 10 1, W 0 2, r 1 7, l 2 3, o 9 1, 2 4, ! -3 2

	    FileOutputStream fstream =
                  new FileOutputStream("Words.dat");
	    DataOutputStream outputFile = 
                  new DataOutputStream(fstream);
    
	    System.out.println("Writing to the file...");
    
	    // Write the array elements to the binary file.
	    for (int i = 0; i < chars.length; i++)
	    {
	    	outputFile.writeChar(chars[i]);
	        outputFile.writeInt(numbers[i*2]);
	        outputFile.writeInt(numbers[i*2+1]);
	    }
	    
	    outputFile.close();
	    System.out.println("Done.");
	    
	}
	
	public void write2RandomFileWithArrays(char[] content, int[] index) throws IOException
	{
		FileOutputStream fstream =
                new FileOutputStream(filename);
	    DataOutputStream outputFile = 
                new DataOutputStream(fstream);
	    
	    for (int i = 0; i < content.length; i++)
	    {
	    	outputFile.writeChar(content[i]);
	        outputFile.writeInt(index[2*i]);
	        outputFile.writeInt(index[2*i+1]);
	    }
	    
	    outputFile.close();
	    System.out.println("Done and close Fiile "+ filename);
		
	}
	
	public String readFrmRandomFile() throws IOException
	{
		String result = new String();
		
		RandomAccessFile randomFile = new RandomAccessFile(filename, "r");
		

	    char ch = randomFile.readChar();
	    result += ch;
		int value1 = randomFile.readInt();
		int value2 = randomFile.readInt();
		
		
		
		while(value1+value2 != -1)
		{
			randomFile.seek((value1+value2)*sizeofWord);
	    	ch = randomFile.readChar();
	    	result += ch;
	    	value1 = randomFile.readInt();
	    	value2 = randomFile.readInt();
		}
		return result;
	}

}
